Video for Linux Two API Specification: Revision 0.24
Prev |  | Next

# ioctl VIDIOC_G_AUDIO, VIDIOC_S_AUDIO

## Name

VIDIOC_G_AUDIO, VIDIOC_S_AUDIO -- Query or select the current audio input and its attributes

## Synopsis

``int ioctl`(int fd, int request, struct v4l2_audio *argp);`

``int ioctl`(int fd, int request, const struct v4l2_audio *argp);`

## Arguments

`fd`

  File descriptor returned by `open()`.

`request`

  VIDIOC_G_AUDIO, VIDIOC_S_AUDIO

`argp`

## Description

To query the current audio input applications zero out the `reserved` array of a struct v4l2_audio and call the `VIDIOC_G_AUDIO` ioctl with a pointer to this structure. Drivers fill the rest of the structure or return an EINVAL error code when the device has no audio inputs, or none which combine with the current video input.

Audio inputs have one writable property, the audio mode. To select the current audio input and change the audio mode, applications initialize the `index` and `mode` fields, and the `reserved` array of a `v4l2_audio` structure and call the `VIDIOC_S_AUDIO` ioctl. Drivers may switch to a different audio mode if the request cannot be satisfied. However, this is a write-only ioctl, it does not return the actual new audio mode.

Table 1. struct `v4l2_audio`

__u32 | `index` | Identifies the audio input, set by the driver or application.
__u8 | `name`[32] | Name of the audio input, a NUL-terminated ASCII string, for example: "Line In". This information is intended for the user, preferably the connector label on the device itself.
__u32 | `capability` | Audio capability flags, see Table 2.
__u32 | `mode` | Audio mode flags set by drivers and applications (on `VIDIOC_S_AUDIO` ioctl), see Table 3.
__u32 | `reserved`[2] | Reserved for future extensions. Drivers and applications must set the array to zero.

Table 2. Audio Capability Flags

`V4L2_AUDCAP_STEREO` | 0x00001 | This is a stereo input. The flag is intended to automatically disable stereo recording etc. when the signal is always monaural. The API provides no means to detect if stereo is received, unless the audio input belongs to a tuner.
`V4L2_AUDCAP_AVL` | 0x00002 | Automatic Volume Level mode is supported.

Table 3. Audio Mode Flags

`V4L2_AUDMODE_AVL` | 0x00001 | AVL mode is on.

## Return Value

On success 0 is returned, on error -1 and the `errno` variable is set appropriately:

EINVAL

  No audio inputs combine with the current video input, or the number of the selected audio input is out of bounds or it does not combine, or there are no audio inputs at all and the ioctl is not supported.

EBUSY

  I/O is in progress, the input cannot be switched.

Prev | Home | Next
ioctl VIDIOC_ENUMSTD | Up | ioctl VIDIOC_G_AUDOUT, VIDIOC_S_AUDOUT